require_relative 'treasure_trove'
require_relative 'playable'

module StudioGame
class Player
  include Playable
  attr_accessor :name
  attr_reader :health

  def initialize(player, health = 100)
    @name = player.capitalize
    @health = health
    @found_treasures = Hash.new(0)
  end

  def each_found_treasure
    @found_treasures.each do |name, points|
      treasure = Treasure.new(name, points)
      yield treasure
    end
  end

  def points 
    @found_treasures.values.reduce(0, :+)
  end

  def found_treasure(treasure)
    @found_treasures[treasure.name] += treasure.value
    puts "#{@name} found a #{treasure.name} worth #{treasure.value} points."
    puts "#{@name}'s treasures: #{@found_treasures}"
  end

  def w00t
    @health = @health + 15
    puts "#{@name} got w00ted!"
  end

  def blam
    @health = @health - 10
    puts "#{@name} got blammed!"
  end

  def score
    @health + points
  end

  def <=>(other_player)
    other_player.score <=> score
  end

  def strong?
    @health > 100
  end

  def self.from_csv(string)
    name, health = string.split(',')
    player = Player.new(name, Integer(health))
  end

  def to_csv
    "#{@name}, #{points}"
  end

  def to_s
    "#{@name} currently has a health of #{@health}, #{points} points, and a score of #{score}\n "
  end  
end
end

if __FILE__ == $0
  player = Player.new("moe")
  puts player.name
  puts player.health
  player.w00t
  puts player.health
  player.blam
  puts player.health
end
